 
    #include "minigui.ch"

    function _DefineComboSearchBox( cname,cparent, ncol, nrow, nwidth, nheight, cvalue, ;
                cfontname, nfontsize, ctooltip, nmaxlenght, ;
                            lupper, llower, lnumeric, ;
                blostfocus, bgotfocus, benter, ;
                lRightAlign, nhelpid, lbold, litalic, lunderline, abackcolor , afontcolor , lnotabstop, aarray )
       DEFAULT nWidth     := 120
       DEFAULT nHeight    := 24
       DEFAULT cValue     := ""
       DEFAULT bGotFocus  := ""
       DEFAULT bLostFocus := ""
       DEFAULT nMaxLenght := 255
       DEFAULT lUpper     := .f.
       DEFAULT lLower     := .f.
       DEFAULT lNumeric   := .f.
       DEFAULT bEnter     := ""
       public parentname := '',;
              cTxBname := cname,;
               aItems := aArray
      if _HMG_SYSDATA [ 264 ] = .T.
         parentname := _HMG_SYSDATA [ 223 ]
      else
         parentname := cparent
      endif


        DEFINE TEXTBOX &cname
           PARENT   &cparent
           ROW      nrow
           COL      ncol
           WIDTH    nwidth
           HEIGHT   nheight
           value    cValue
           FONTNAME cfontname
           FONTSIZE nFontsize
           tooltip  ctooltip
           maxlength nmaxlenght
           uppercase lupper
           lowercase llower
           numeric lnumeric
           onlostfocus blostfocus
           ongotfocus bgotfocus
           onenter benter
           ONCHANGE createcsbox()
           rightalign lrightalign
           helpid nhelpid
           fontbold lbold
           fontitalic litalic
           fontunderline lunderline
           backcolor abackcolor
           fontcolor afontcolor
           tabstop lnotabstop
        END textbox
    return nil   


    *-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

    function createcsbox
    local formname := thiswindow.name
    local formrow := thiswindow.row
    local formcol := thiswindow.col
    local controlrow := this.row
    local controlcol := this.col
    local controlwidth := this.width
    local controlheight := this.height
    local curvalue := this.value
    local aresults := {}
    local result := 0
    local i := 0
    local listboxheight := 0
    local caret := this.CaretPos

    if !empty(curvalue)
       for i := 1 to len(aitems)
          if upper(aitems[i]) == upper(curvalue)
             return nil //item selected already
          endif
          if upper(left(aitems[i],len(curvalue))) == upper(curvalue)
             aadd(aresults,aitems[i])
          endif
       next i
       if len(aresults) > 0
          listboxheight := max(min((len(aresults) * 16)+60,thiswindow.height - controlrow - controlheight-10),40)
          define window _hmg_csbox at formrow+controlrow+20,formcol+controlcol width controlwidth+6 height listboxheight+controlheight title '' modal nocaption nosize //on interactiveclose _hmg_csbox.release()
             define textbox _cstext
                row 3
                col 3
                width controlwidth
                height controlheight
               FONTNAME this.fontname
                 FONTSIZE this.Fontsize
                 tooltip  this.tooltip
                 fontbold this.fontbold
                 fontitalic this.fontitalic
                 fontunderline this.fontunderline
                 backcolor this.backcolor
                 fontcolor this.fontcolor
                on change _cstextchanged()
                on enter _csitemselected()
             end textbox
             define listbox _cslist
                row controlheight+3
                col 3
                width controlwidth
                height listboxheight
                items aresults
                on dblclick _csitemselected()
                value 1
             end listbox
          end window
          on key UP of _hmg_csbox action _csdoupkey()
          on key DOWN of _hmg_csbox action _csdodownkey()
          on key ESCAPE of _hmg_csbox action _csdoesckey()
          _hmg_csbox._cstext.value := curvalue
          _hmg_csbox._cstext.CaretPos := caret
          _hmg_csbox.activate()
       endif
    endif   
    return nil         
       
    function _cstextchanged
    local curvalue := _hmg_csbox._cstext.value
    local aresults := {}
    local result := 0
    local i := 0
    local listboxheight := 0
    local parentheight := getproperty(parentname,"HEIGHT")
    local parentrow := getproperty(parentname,"ROW")
    _hmg_csbox._cslist.deleteallitems()
    for i := 1 to len(aitems)
       if upper(left(aitems[i],len(curvalue))) == upper(curvalue)
          aadd(aresults,aitems[i])
       endif
    next i
    if len(aresults) > 0
       for i := 1 to len(aresults)
          _hmg_csbox._cslist.additem(aresults[i])
       next i
       _hmg_csbox._cslist.value := 1
    endif
    listboxheight := max(min((len(aresults) * 16)+6,(parentheight + parentrow - _hmg_csbox.row - _hmg_csbox._cstext.row - _hmg_csbox._cstext.height - 14)),40)
    _hmg_csbox._cslist.height := listboxheight
    _hmg_csbox.height := listboxheight+_hmg_csbox._cstext.height
    return nil   
       
    function _csitemselected
    if _hmg_csbox._cslist.value > 0
       setproperty(parentname,cTxBName,"VALUE",_hmg_csbox._cslist.item(_hmg_csbox._cslist.value))
       setproperty(parentname,cTxBName,"CARETPOS",len(_hmg_csbox._cslist.item(_hmg_csbox._cslist.value)))
       _hmg_csbox.release()
    endif
    return nil

    function _csdoupkey
    if _hmg_csbox._cslist.itemcount > 0 .and. _hmg_csbox._cslist.value > 1
       _hmg_csbox._cslist.value := _hmg_csbox._cslist.value - 1
    endif
    return nil

    function _csdodownkey
    if _hmg_csbox._cslist.itemcount > 0 .and. _hmg_csbox._cslist.value < _hmg_csbox._cslist.itemcount
       _hmg_csbox._cslist.value := _hmg_csbox._cslist.value + 1
    endif
    return nil
   
    function _csdoesckey
    setproperty(parentname,cTxBName,"VALUE",'')
    _hmg_csbox.release()
    return nil

